#include <hmg.ch>

Function Main
private aDepartments := {"Cakes","Confectionery","Ice Creams"}
private aItems := {{"Coffee Cake","Roll Cake","Milky Cake"},{"Dairy Milk","Nutrine","Parrys"},{"Italian Delight","Pista","Vennila"}}

define window sample at 0,0 width 800 height 600 main
   define textbox dummy
      row 10
      col 10
      width 100
   end textbox

   define grid g1
      row 40
      col 10
      headers {"Department","Item Name","Quantity"}
      widths {200,200,200}
      width 630
      height 200
      justify {0,0,1}
      columncontrols {{"TEXTBOX","CHARACTER"},{"TEXTBOX","CHARACTER"},{"TEXTBOX","NUMERIC","99999.99"}}
      items {{"Cakes","Roll Cake",100.00},{"Confectionery","Parrys",200.00},{"Ice Creams","Italian Delight",5.00}}
      columnwhen {{||ItemSelectCol1()},{||ItemSelectCol2()},.t.}
      value {1,1}
      allowedit .t.
      cellnavigation .t.
   end grid 
   define textbox dummy1
      row 250
      col 10
      width 100
   end textbox
   define statusbar
      statusitem "Press F2 for adding new line"
   end statusbar   
end window
on key F2 of sample action addnewitem()
sample.center
sample.activate
Return nil

function itemselectcol1
local aValue := this.value
local cItemBefore := ""
local cItemAfter := ""
cItemBefore := this.cell(aValue[1],1) 
this.cell(aValue[1],1) := hmg_achoice(this.cellrow,this.cellcol,this.cellwidth,this.cellheight,aDepartments,this.cell(aValue[1],1))
cItemAfter := this.cell(aValue[1],1) 
if cItemBefore <> cItemAfter
   this.cell(aValue[1],2) := ""
endif    
this.value := {aValue[1],2}
return .f.

function itemselectcol2
local aValue := this.value
local nFound := 0
if .not. empty(this.cell(aValue[1],1))
   nFound := ascan(aDepartments,this.cell(aValue[1],1))
   if nFound > 0
      this.cell(aValue[1],2) := hmg_achoice(this.cellrow,this.cellcol,this.cellwidth,this.cellheight,aItems[nFound],this.cell(aValue[1],2))
   endif
endif
this.value := {aValue[1],3}
return .f.



function addnewitem
local aValue
local nRow := 0
if .not. empty(sample.g1.cell(sample.g1.itemcount,1))
   sample.g1.additem({"","",0.0})
   sample.g1.value := {sample.g1.itemcount,1}
endif      
return nil

