# include "hmg.ch"


    function HMG_Achoice(nRow,nCol,nWidth,nHeight,aList,cDefault,lAnyWhere)
    local nFormRow := thiswindow.row
    local nFormCol := thiswindow.col
    local nFormWidth := thiswindow.width
    local nFormHeight := thiswindow.height
    local nFound := 0
    local i := 0
    private _aItems := aclone(aList)
    private _nSelected := 0
    private lAnyWhereSearch := .f.
    private cParentForm := thiswindow.name
    private cThisControl := this.name
    private cItemSelected := ""
    default lAnyWhere := .f.
    default cDefault := ""
    lAnyWhereSearch := lAnyWhere
    if .not. iswindowdefined(_HMG_AChoice)
       DEFINE WINDOW _HMG_aChoice AT     nFormRow + 23 + nRow + IF ( IsAppThemed() , 5 , 0 ), nFormCol + nCol + 4 +IF ( IsAppThemed() , 3 , 0 );
                   WIDTH  nWidth  ;
                   HEIGHT nFormHeight - (nRow) - 40 ;
                   TITLE '' ;
                   MODAL ;
                   NOCAPTION;
                   NOSIZE 
          define textbox _edit
             row 0
             col 0
             width nWidth
             height nHeight
             ON CHANGE     _aChoiceTextChanged( lAnyWhere )
             ON ENTER      _aChoiceSelected(  )
          end textbox
          define listbox _list
             row nHeight + 2
             col 0
             width nWidth
             height nFormHeight - (nRow) - 40 - (nHeight + 2)
             items aList
             on change _achoicelistchanged()
             ON DBLCLICK _aChoiceSelected(  )
          end listbox
       end window
       ON KEY UP     OF _HMG_achoice ACTION _aChoiceDoUpKey() 
       ON KEY DOWN   OF _HMG_achoice ACTION _aChoiceDoDownKey()
       ON KEY ESCAPE OF _HMG_achoice ACTION _aChoiceDoEscKey()
       ON KEY TAB    OF _HMG_achoice ACTION _aChoiceselected() 
       _hmg_sysdata[296] := {||_aChoiceselected()}
       if len(_aItems) > 0
          if len(alltrim(cDefault)) > 0
             _HMG_aChoice._edit.value := cDefault
          endif                
       endif       
       _HMG_Achoice.activate
       _hmg_sysdata[296] := nil
//       inserttab()
    else
       _hmg_sysdata[296] := nil
//       inserttab()   
    endif      
    return cItemSelected

    STATIC PROC _aChoiceTextChanged( lAnyWhere )

       LOCAL cCurValue      := _HMG_aChoice._edit.value
       LOCAL nItemNo        := 0
       local lFound := .f.
       
       FOR nItemNo := 1 TO LEN(_aitems)
          IF lAnyWhere
             IF AT(UPPER(cCurValue),UPPER(_aItems[nItemNo])) > 0
                _HMG_aChoice._list.value := nItemNo
                lFound := .t.
                exit
             ENDIF           
          ELSE
             IF UPPER( LEFT( _aitems[ nItemNo ], LEN(cCurValue))) == UPPER(cCurValue)
                _HMG_aChoice._list.value := nItemNo
                lFound := .t.
                exit
             ENDIF
          ENDIF   
       NEXT nItemNo
       if .not. lFound
          _HMG_aChoice._list.value := 0
       endif
    RETURN 

    function _aChoiceselected
    if _HMG_aChoice._List.value > 0
       cItemSelected := _HMG_aChoice._List.item(_HMG_aChoice._List.value)
    else
       cItemSelected := ""
    endif
    release window _HMG_aChoice
    return nil

    function _aChoiceDoUpKey()
       IF _HMG_aChoice._List.value > 1
          _HMG_aChoice._List.value := _HMG_aChoice._List.value - 1
          _HMG_aChoice._edit.value := _HMG_aChoice._List.item(_HMG_aChoice._List.value)
          textboxeditsetsel("_HMG_aChoice","_Edit",0,-1)
       ENDIF
    return nil
     
    function _aChoiceDoDownKey()
       IF _HMG_aChoice._List.value < _HMG_aChoice._List.ItemCount
          _HMG_aChoice._List.value := _HMG_aChoice._List.value + 1
          _HMG_aChoice._edit.value := _HMG_aChoice._List.item(_HMG_aChoice._List.value)
          textboxeditsetsel("_HMG_aChoice","_Edit",0,-1)
       ENDIF
    return nil

    function _aChoiceDoEscKey()
    cItemSelected := ""
    release window _HMG_aChoice
    return nil

    function _achoicelistchanged
    if upper(this.name) == "_EDIT" .and. upper(thiswindow.name) == "_HMG_ACHOICE" .and. .not. lAnyWhereSearch
       _HMG_aChoice._edit.value := _HMG_aChoice._List.item(_HMG_aChoice._List.value)
       textboxeditsetsel("_HMG_aChoice","_Edit",0,-1)
    endif   
    return nil


    function textboxeditsetsel(cParent,cControl,nStart,nEnd)
    local nHandle := GetControlHandle (cControl,cParent)
    textboxsetsel(nHandle,nStart,nEnd)
    return nil

    #pragma BEGINDUMP

    #include <windows.h>
    #include <commctrl.h>
    #include "hbapi.h"
    #include <wingdi.h>

    HB_FUNC ( TEXTBOXSETSEL )
    {
       HWND hWnd1;
       hWnd1 = (HWND) hb_parnl (1);
       SendMessage((HWND) hWnd1,EM_SETSEL, (WPARAM)(int) hb_parni(2),(LPARAM) (int) hb_parni(3));
    }

    #pragma ENDDUMP


